searchNodes=[{"doc":"A bin responsible for doing framerate conversion on all input videos and piping them into the compositor element. Bin options Passed via struct Membrane.VideoCompositor.t/0 stream_format Membrane.RawVideo . t ( ) Required Stream format for the output video of the compositor Pads :input Accepted formats: % Membrane.RawVideo { pixel_format : :I420 } Direction: :input Availability: :on_request Mode: :pull Demand unit: :buffers Pad options: initial_placement BaseVideoPlacement . t ( ) Required Initial placement of the video on the screen timestamp_offset Membrane.Time . non_neg_t ( ) Default value: 0 Input stream PTS offset in nanoseconds. Must be non-negative. initial_video_transformations VideoTransformations . t ( ) Default value: nil Specify the initial types and the order of transformations applied to video. :output Accepted formats: % Membrane.RawVideo { pixel_format : :I420 } Direction: :output Availability: :always Mode: :pull Demand unit: :buffers","ref":"Membrane.VideoCompositor.html","title":"Membrane.VideoCompositor","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.VideoCompositor.html#options/0","title":"Membrane.VideoCompositor.options/0","type":"function"},{"doc":"Options for pad :input","ref":"Membrane.VideoCompositor.html#t:input_pad_opts_t/0","title":"Membrane.VideoCompositor.input_pad_opts_t/0","type":"type"},{"doc":"Struct containing options for Membrane.VideoCompositor","ref":"Membrane.VideoCompositor.html#t:t/0","title":"Membrane.VideoCompositor.t/0","type":"type"},{"doc":"A message describing a compositor video placement update","ref":"Membrane.VideoCompositor.html#t:update_placement/0","title":"Membrane.VideoCompositor.update_placement/0","type":"type"},{"doc":"A message describing a compositor video transformations update","ref":"Membrane.VideoCompositor.html#t:update_transformations/0","title":"Membrane.VideoCompositor.update_transformations/0","type":"type"},{"doc":"An easy example simulates the layout of a video conferencing app. There are 4 video inputs. All of them get their corners rounded. Then, one of them is chosen as a main video (which takes most of the screen), while the rest are scaled-down and put in a side strip on top of the main video.","ref":"Membrane.VideoCompositor.Examples.Easy.html","title":"Membrane.VideoCompositor.Examples.Easy","type":"module"},{"doc":"A hard example takes three videos, applies varied transformations to them, and puts them together on the final canvas The first video is simply rotated and then put in the top left corner The second video is merged with the first video. The result gets corner rounded and is put in the top right corner The third video is turned into a ball and put in the middle bottom of the screen","ref":"Membrane.VideoCompositor.Examples.Hard.html","title":"Membrane.VideoCompositor.Examples.Hard","type":"module"},{"doc":"Mock Grid Layout. Videos placements are defined by the :video_count parameter. Mocks some components defining different video arrangements for a different number of input sources.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Grid.html","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Grid","type":"module"},{"doc":"","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Grid.html#t:t/0","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Grid.t/0","type":"type"},{"doc":"Mocks simple component combing two videos / frames / inputs into one.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Merging.html","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Merging","type":"module"},{"doc":"","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Merging.html#t:t/0","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Merging.t/0","type":"type"},{"doc":"Mocks Overlay layout. Videos are places on output frame based on their given position.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Overlay.html","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Overlay","type":"module"},{"doc":"A name used to identify placing of an objects.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Overlay.html#t:placing_name/0","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Overlay.placing_name/0","type":"type"},{"doc":"Specify how each input texture (received either from the input pad or rendered as an output of the previous object) maps on the rendered output of Overlay.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Overlay.html#t:t/0","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Overlay.t/0","type":"type"},{"doc":"A structure representing position of an object in rendered frame.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Position.html","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Position","type":"module"},{"doc":"","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Position.html#t:t/0","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Position.t/0","type":"type"},{"doc":"Float in [0, 1] range. Widely used in graphic rendering, to determine distance, color etc.","ref":"Membrane.VideoCompositor.Examples.Mock.Layouts.Position.html#t:unit_range/0","title":"Membrane.VideoCompositor.Examples.Mock.Layouts.Position.unit_range/0","type":"type"},{"doc":"A struct describing the video position, size and z-value for use with the rust-based compositor on the output frame, before video transformations. Values position: tuple given in pixels, relative to the top right corner of the output frame, represents the position on the output frame before transformations size: tuple given in pixels, represents video resolution on the output frame before transformations z_value: float in [0.0, 1.0] range, specifies priority: videos with higher z_value s are 'in front' of videos with lower z_value s Examples If you want to place the video in the bottom left quarter of the 4k output frame, above videos on 0.0 z_value level: iex&gt; alias Membrane.VideoCompositor.RustStructs.BaseVideoPlacement Membrane.VideoCompositor.RustStructs.BaseVideoPlacement iex&gt; % BaseVideoPlacement { position : { 1920 , 1080 } , size : { 1920 , 1080 } , z_value : 0.5 } % Membrane.VideoCompositor.RustStructs.BaseVideoPlacement { position : { 1920 , 1080 } , size : { 1920 , 1080 } , z_value : 0.5 }","ref":"Membrane.VideoCompositor.RustStructs.BaseVideoPlacement.html","title":"Membrane.VideoCompositor.RustStructs.BaseVideoPlacement","type":"module"},{"doc":"","ref":"Membrane.VideoCompositor.RustStructs.BaseVideoPlacement.html#t:t/0","title":"Membrane.VideoCompositor.RustStructs.BaseVideoPlacement.t/0","type":"type"},{"doc":"Structure representing a top level specification of what is Video Compositor supposed to render.","ref":"Membrane.VideoCompositor.Scene.html","title":"Membrane.VideoCompositor.Scene","type":"module"},{"doc":"The main part of the Scene are Membrane.VideoCompositor.Scene.Object s and interactions between them. There are three kinds of Objects: Membrane.VideoCompositor.Scene.Object.InputVideo - which maps an input pad of element into Scene object. Membrane.VideoCompositor.Scene.Object.Texture - single input object, taking frames and applying a series of transformations onto it. Membrane.VideoCompositor.Scene.Object.Layout - combining frames from multiple inputs into a single output.","ref":"Membrane.VideoCompositor.Scene.html#t:t/0","title":"Membrane.VideoCompositor.Scene.t/0","type":"type"},{"doc":"This module holds common types for different kinds of Objects available.","ref":"Membrane.VideoCompositor.Scene.Object.html","title":"Membrane.VideoCompositor.Scene.Object","type":"module"},{"doc":"Defines how an object can be referenced in Scene. Objects can be assigned to names and identified at other objects as inputs based on assigned names","ref":"Membrane.VideoCompositor.Scene.Object.html#t:name/0","title":"Membrane.VideoCompositor.Scene.Object.name/0","type":"type"},{"doc":"Defines how the output resolution of an object can be specified. Additionally, in Textures resolution can be specified as transformed resolution of the object input (e.g. for corners rounding - same as input, for cropping - accordingly smaller than input)","ref":"Membrane.VideoCompositor.Scene.Object.html#t:object_output_resolution/0","title":"Membrane.VideoCompositor.Scene.Object.object_output_resolution/0","type":"type"},{"doc":"Objects are renderable entities in VC, that can serve as input for other objects or as an output of the video. They are either Texture structs, structs defining Layouts following Layout.t() definition or InputVideo structs.","ref":"Membrane.VideoCompositor.Scene.Object.html#t:t/0","title":"Membrane.VideoCompositor.Scene.Object.t/0","type":"type"},{"doc":"Structure representing InputVideo wrapper for using input Membrane Pad of an element as a object in a scene.","ref":"Membrane.VideoCompositor.Scene.Object.InputVideo.html","title":"Membrane.VideoCompositor.Scene.Object.InputVideo","type":"module"},{"doc":"Defines pad wrapper.","ref":"Membrane.VideoCompositor.Scene.Object.InputVideo.html#t:t/0","title":"Membrane.VideoCompositor.Scene.Object.InputVideo.t/0","type":"type"},{"doc":"Structure representing Layout objects. Layouts can take multiple renderable objects as input and combine them into one frame. Fadings, Grids, Overlays, Transitions, etc. can be defined as Layouts. Basically it's a multi-input, single-output node in processing graph.","ref":"Membrane.VideoCompositor.Scene.Object.Layout.html","title":"Membrane.VideoCompositor.Scene.Object.Layout","type":"module"},{"doc":"Type of a map defining on how to map internal layout's ids to Scene objects","ref":"Membrane.VideoCompositor.Scene.Object.Layout.html#t:inputs/0","title":"Membrane.VideoCompositor.Scene.Object.Layout.inputs/0","type":"type"},{"doc":"Defines how the output resolution of a layout texture can be specified. Texture resolution can be specified as: plain Membrane.VideoCompositor.Resolution.t() resolution of another object","ref":"Membrane.VideoCompositor.Scene.Object.Layout.html#t:output_resolution/0","title":"Membrane.VideoCompositor.Scene.Object.Layout.output_resolution/0","type":"type"},{"doc":"Specify that Layouts: should be defined as structs should have :inputs and :resolution fields can have custom fields","ref":"Membrane.VideoCompositor.Scene.Object.Layout.html#t:t/0","title":"Membrane.VideoCompositor.Scene.Object.Layout.t/0","type":"type"},{"doc":"Texture takes a frame received from Video Compositor objects, applies all transformations and can be passed as an input to other objects. Basically wraps multiple single-input, single-output processing graph nodes.","ref":"Membrane.VideoCompositor.Scene.Object.Texture.html","title":"Membrane.VideoCompositor.Scene.Object.Texture","type":"module"},{"doc":"Defines how the output resolution of a texture can be specified. Texture resolution can be specified as: plain Membrane.VideoCompositor.Resolution.t() resolution of another object transformed resolution of the object input (e.g. for corners rounding - same as input, for cropping - accordingly smaller than input)","ref":"Membrane.VideoCompositor.Scene.Object.Texture.html#t:output_resolution/0","title":"Membrane.VideoCompositor.Scene.Object.Texture.output_resolution/0","type":"type"},{"doc":"Defines texture object, that takes frames from input Object (rendered frame), applies all transformations sequentially and can be passed as an input for other objects.","ref":"Membrane.VideoCompositor.Scene.Object.Texture.html#t:t/0","title":"Membrane.VideoCompositor.Scene.Object.Texture.t/0","type":"type"},{"doc":"Simple resolution definition.","ref":"Membrane.VideoCompositor.Scene.Resolution.html","title":"Membrane.VideoCompositor.Scene.Resolution","type":"module"},{"doc":"Defines frame / video resolution.","ref":"Membrane.VideoCompositor.Scene.Resolution.html#t:t/0","title":"Membrane.VideoCompositor.Scene.Resolution.t/0","type":"type"},{"doc":"Module representing single-input, single-output frames processing graph nodes that apply a single effect on the input frame (e.g. crop them or round corners). Transformations can change frame resolution. Cropping, CornersRounding, ColorFiler, RollToBall, etc. can be implemented as transformations.","ref":"Membrane.VideoCompositor.Scene.Transformation.html","title":"Membrane.VideoCompositor.Scene.Transformation","type":"module"},{"doc":"Specify how Transformations can be defined: By struct - when transformation can be parametrized with different values e.g. corners round (parametrized with border-radius), cropping, etc. By module - when there are no reasonable / common use cases of parametrization, and identifying transformation without it is enough e.g. RollToBall - transformation turning input object / frame / video into the ball","ref":"Membrane.VideoCompositor.Scene.Transformation.html#t:definition/0","title":"Membrane.VideoCompositor.Scene.Transformation.definition/0","type":"type"},{"doc":"","ref":"Membrane.VideoCompositor.Scene.Transformation.html#t:name/0","title":"Membrane.VideoCompositor.Scene.Transformation.name/0","type":"type"},{"doc":"Describes all transformations applied to the video. Order of transformations matters. Transformations are applied in the order in which they appear in the list.","ref":"Membrane.VideoCompositor.VideoTransformations.html","title":"Membrane.VideoCompositor.VideoTransformations","type":"module"},{"doc":"","ref":"Membrane.VideoCompositor.VideoTransformations.html#empty/0","title":"Membrane.VideoCompositor.VideoTransformations.empty/0","type":"function"},{"doc":"","ref":"Membrane.VideoCompositor.VideoTransformations.html#t:t/0","title":"Membrane.VideoCompositor.VideoTransformations.t/0","type":"type"},{"doc":"Describes all texture transformations applied to video. Texture transformations can change resolution of frame. Applying texture transformations may change size of video on the output frame (e.x. adding border to video will make video larger). As a contributor adding a new type of texture transformation, you must create new struct module type and add it to this type definition.","ref":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.html","title":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations","type":"module"},{"doc":"","ref":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.html#t:t/0","title":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.t/0","type":"type"},{"doc":"Describe corners rounding texture transformation parameter. Corner rounding transformation can be imagined as placing four circles with specified radius adjoining to frame borders, placed inside frame and making space between circle edge and nearest frame corner transparent. Values border_radius: non negative integer representing radius of circle &quot;cutting&quot; frame corner part. Examples Example struct describing transformation which rounds corners with 100 pixel radius: iex&gt; alias Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding iex&gt; % CornersRounding { border_radius : 100 } % Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding { border_radius : 100 }","ref":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding.html","title":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding","type":"module"},{"doc":"Describe cropping texture transformation parameter.","ref":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding.html#t:t/0","title":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.CornersRounding.t/0","type":"type"},{"doc":"Describe cropping texture transformation parameters. Values crop_top_left_corner: tuple representing coords (in [0, 1] range) of top left corner of the visible part of video crop_size: tuple representing width and height (in [0, 1] range) of the visible part of video cropped_video_position: optional atom, describe whether cropped video part should remain in cropped part or should be in position of video before transformation. For more reference see Examples section below. Examples Struct describing transformation, which displays only bottom right quarter of input video, with cropped part remaining in its position: iex&gt; alias Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping iex&gt; % Cropping { crop_top_left_corner : { 0.5 , 0.5 } , crop_size : { 0.5 , 0.5 } , cropped_video_position : :crop_part_position # can be omitted, this is default value } % Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping { crop_top_left_corner : { 0.5 , 0.5 } , crop_size : { 0.5 , 0.5 } , cropped_video_position : :crop_part_position } Struct describing transformation, which displays only right part of input video in left part of input video: iex&gt; alias Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping iex&gt; % Cropping { crop_top_left_corner : { 0.5 , 0.0 } , crop_size : { 0.5 , 1.0 } , cropped_video_position : :input_position } % Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping { crop_top_left_corner : { 0.5 , 0.0 } , crop_size : { 0.5 , 1.0 } , cropped_video_position : :input_position }","ref":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping.html","title":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping","type":"module"},{"doc":"Describe cropping texture transformation parameters.","ref":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping.html#t:t/0","title":"Membrane.VideoCompositor.VideoTransformations.TextureTransformations.Cropping.t/0","type":"type"},{"doc":"Membrane plugin that accepts multiple video inputs, transforms them according to provided transformations and composes them into a single output video. It is part of Membrane Multimedia Framework .","ref":"readme.html","title":"Membrane Video Compositor Plugin","type":"extras"},{"doc":"The package can be installed by adding membrane_video_compositor_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_video_compositor_plugin , &quot;~&gt; 0.2.2&quot; } ] end Since parts of this package are implemented in Rust, you need to have a Rust installation to compile this package. You can get one here","ref":"readme.html#installation","title":"Membrane Video Compositor Plugin - Installation","type":"extras"},{"doc":"TODO","ref":"readme.html#usage","title":"Membrane Video Compositor Plugin - Usage","type":"extras"},{"doc":"Copyright 2022, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane Video Compositor Plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2022 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]